#include "rhs.hpp"
#include <cmath>
#include "BioreactorGlobalDefs.h"

void rhs(double* f, double* x, double* p, int mode)
{

	if(mode == 0) // Case 1: start with saturation
	{
		f[0] =(-(a/PI)*(InputSat)*x[0]+x[1]*exp(-b*x[1])*x[0])*p[8];
		f[1] =((a/PI)*(InputSat)*((p[2]+p[1])-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180*x[1]))*p[8];
	}
	else if (mode ==1) //Case 2: Start without saturation
	{
		f[0] =(-(a/PI)*((p[3]+p[0])+p[5]*(x[1]-p[4]))*x[0]+x[1]*exp(-b*x[1])*x[0])*p[8];
		f[1] =((a/PI)*((p[3]+p[0])+p[5]*(x[1]-p[4]))*((p[2]+p[1])-x[1])
				- x[1]*exp(-b*x[1])*x[0]/(5.4+180*x[1]))*p[8];
	}
	else
		; // do nothing, this case should never appear


};

void hamilton(double *h, double *x, double *lam, double * p, int mode) {
	double f[2];
	if(mode == 0) // Case 1: start with saturation
	{
		f[0] =(-(a/PI)*(InputSat)*x[0]+x[1]*exp(-b*x[1])*x[0])*p[8];
		f[1] =((a/PI)*(InputSat)*((p[2]+p[1])-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180*x[1]))*p[8];
		h[0]=lam[0]*f[0]+lam[1]*f[1];
	}
	else if (mode ==1) //Case 2: Start without saturation
	{
		f[0] =(-(a/PI)*((p[3]+p[0])+p[5]*(x[1]-p[4]))*x[0]+x[1]*exp(-b*x[1])*x[0])*p[8];
		f[1] =((a/PI)*((p[3]+p[0])+p[5]*(x[1]-p[4]))*((p[2]+p[1])-x[1])
				- x[1]*exp(-b*x[1])*x[0]/(5.4+180*x[1]))*p[8];
		h[0]=lam[0]+f[0] + lam[1]*f[1];
	}
	else
		; // do nothing, this case should never appear

}

/*        Generated by TAPENADE     (INRIA, Tropics team)
    Tapenade 3.4 (r3375) - 10 Feb 2010 15:08


  Differentiation of hamilton in forward (tangent) mode:
   variations   of useful results: *h
   with respect to varying inputs: *lam *p *x
   RW status of diff variables: *lam:in *h:out *p:in *x:in
*/
void hamilton_d(double *h, double *hd, double *x, double *xd, double *lam, 
        double *lamd, double *p, double *pd, int mode) {
    double f[2];
    double fd[2];
    if (mode == 0) {
        // Case 1: start with saturation
        fd[0] = ((xd[1]*x[0]+x[1]*xd[0])*exp(-b*x[1])-a*InputSat*xd[0]/PI-x[1]
            *x[0]*b*xd[1]*exp(-b*x[1]))*p[8] + (-(a/PI)*InputSat*x[0]+x[1]*exp
            (-b*x[1])*x[0])*pd[8];
        f[0] = (-(a/PI)*InputSat*x[0]+x[1]*exp(-b*x[1])*x[0])*p[8];
        fd[1] = (a*InputSat*(pd[2]+pd[1]-xd[1])/PI-(((xd[1]*x[0]+x[1]*xd[0])*
            exp(-b*x[1])-x[1]*x[0]*b*xd[1]*exp(-b*x[1]))*(5.4+180*x[1])-x[1]*
            exp(-b*x[1])*x[0]*180*xd[1])/((5.4+180*x[1])*(5.4+180*x[1])))*p[8]
            + (a/PI*InputSat*(p[2]+p[1]-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180*
            x[1]))*pd[8];
        f[1] = (a/PI*InputSat*(p[2]+p[1]-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180
            *x[1]))*p[8];
        hd[0] = lamd[0]*f[0] + lam[0]*fd[0] + lamd[1]*f[1] + lam[1]*fd[1];
        h[0] = lam[0]*f[0] + lam[1]*f[1];
    } else
        if (mode == 1) {
            //Case 2: Start without saturation
            fd[0] = ((xd[1]*x[0]+x[1]*xd[0])*exp(-b*x[1])-a*((pd[3]+pd[0]+pd[5
                ]*(x[1]-p[4])+p[5]*(xd[1]-pd[4]))*x[0]+(p[3]+p[0]+p[5]*(x[1]-p
                [4]))*xd[0])/PI-x[1]*x[0]*b*xd[1]*exp(-b*x[1]))*p[8] + (-(a/PI
                )*(p[3]+p[0]+p[5]*(x[1]-p[4]))*x[0]+x[1]*exp(-b*x[1])*x[0])*pd
                [8];
            f[0] = (-(a/PI)*(p[3]+p[0]+p[5]*(x[1]-p[4]))*x[0]+x[1]*exp(-b*x[1]
                )*x[0])*p[8];
            fd[1] = (a*((pd[3]+pd[0]+pd[5]*(x[1]-p[4])+p[5]*(xd[1]-pd[4]))*(p[
                2]+p[1]-x[1])+(p[3]+p[0]+p[5]*(x[1]-p[4]))*(pd[2]+pd[1]-xd[1])
                )/PI-(((xd[1]*x[0]+x[1]*xd[0])*exp(-b*x[1])-x[1]*x[0]*b*xd[1]*
                exp(-b*x[1]))*(5.4+180*x[1])-x[1]*exp(-b*x[1])*x[0]*180*xd[1])
                /((5.4+180*x[1])*(5.4+180*x[1])))*p[8] + (a/PI*(p[3]+p[0]+p[5]
                *(x[1]-p[4]))*(p[2]+p[1]-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180
                *x[1]))*pd[8];
            f[1] = (a/PI*(p[3]+p[0]+p[5]*(x[1]-p[4]))*(p[2]+p[1]-x[1])-x[1]*
                exp(-b*x[1])*x[0]/(5.4+180*x[1]))*p[8];
            hd[0] = lamd[0] + fd[0] + lamd[1]*f[1] + lam[1]*fd[1];
            h[0] = lam[0] + f[0] + lam[1]*f[1];
        } else
            *hd = 0.0;
}



/*        Generated by TAPENADE     (INRIA, Tropics team)
    Tapenade 3.4 (r3375) - 10 Feb 2010 15:08


  Differentiation of rhs in forward (tangent) mode:
   variations   of useful results: *f
   with respect to varying inputs: *p *x
   RW status of diff variables: *f:out *p:in *x:in
*/
/*        Generated by TAPENADE     (INRIA, Tropics team)
    Tapenade 3.4 (r3375) - 10 Feb 2010 15:08


  Differentiation of rhs in forward (tangent) mode:
   variations   of useful results: *f
   with respect to varying inputs: *p *x
   RW status of diff variables: *f:out *p:in *x:in
*/
void rhs_d(double *f, double *fd, double *x, double *xd, double *p, double *pd
        , int mode) {
    if (mode == 0) {
        // Case 1: start with saturation
        fd[0] = ((xd[1]*x[0]+x[1]*xd[0])*exp(-b*x[1])-a*InputSat*xd[0]/PI-x[1]
            *x[0]*b*xd[1]*exp(-b*x[1]))*p[8] + (-(a/PI)*InputSat*x[0]+x[1]*exp
            (-b*x[1])*x[0])*pd[8];
        f[0] = (-(a/PI)*InputSat*x[0]+x[1]*exp(-b*x[1])*x[0])*p[8];
        fd[1] = (a*InputSat*(pd[2]+pd[1]-xd[1])/PI-(((xd[1]*x[0]+x[1]*xd[0])*
            exp(-b*x[1])-x[1]*x[0]*b*xd[1]*exp(-b*x[1]))*(5.4+180*x[1])-x[1]*
            exp(-b*x[1])*x[0]*180*xd[1])/((5.4+180*x[1])*(5.4+180*x[1])))*p[8]
            + (a/PI*InputSat*(p[2]+p[1]-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180*
            x[1]))*pd[8];
        f[1] = (a/PI*InputSat*(p[2]+p[1]-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180
            *x[1]))*p[8];
    } else
        if (mode == 1) {
            //Case 2: Start without saturation
            fd[0] = ((xd[1]*x[0]+x[1]*xd[0])*exp(-b*x[1])-a*((pd[3]+pd[0]+pd[5
                ]*(x[1]-p[4])+p[5]*(xd[1]-pd[4]))*x[0]+(p[3]+p[0]+p[5]*(x[1]-p
                [4]))*xd[0])/PI-x[1]*x[0]*b*xd[1]*exp(-b*x[1]))*p[8] + (-(a/PI
                )*(p[3]+p[0]+p[5]*(x[1]-p[4]))*x[0]+x[1]*exp(-b*x[1])*x[0])*pd
                [8];
            f[0] = (-(a/PI)*(p[3]+p[0]+p[5]*(x[1]-p[4]))*x[0]+x[1]*exp(-b*x[1]
                )*x[0])*p[8];
            fd[1] = (a*((pd[3]+pd[0]+pd[5]*(x[1]-p[4])+p[5]*(xd[1]-pd[4]))*(p[
                2]+p[1]-x[1])+(p[3]+p[0]+p[5]*(x[1]-p[4]))*(pd[2]+pd[1]-xd[1])
                )/PI-(((xd[1]*x[0]+x[1]*xd[0])*exp(-b*x[1])-x[1]*x[0]*b*xd[1]*
                exp(-b*x[1]))*(5.4+180*x[1])-x[1]*exp(-b*x[1])*x[0]*180*xd[1])
                /((5.4+180*x[1])*(5.4+180*x[1])))*p[8] + (a/PI*(p[3]+p[0]+p[5]
                *(x[1]-p[4]))*(p[2]+p[1]-x[1])-x[1]*exp(-b*x[1])*x[0]/(5.4+180
                *x[1]))*pd[8];
            f[1] = (a/PI*(p[3]+p[0]+p[5]*(x[1]-p[4]))*(p[2]+p[1]-x[1])-x[1]*
                exp(-b*x[1])*x[0]/(5.4+180*x[1]))*p[8];
        } else
            *fd = 0.0;
}







/*        Generated by TAPENADE     (INRIA, Tropics team)
    Tapenade 3.4 (r3375) - 10 Feb 2010 15:08


  Differentiation of rhs in reverse (adjoint) mode:
   gradient     of useful results: *f
   with respect to varying inputs: *f *p *x
   RW status of diff variables: *f:in-out *p:out *x:out
*/
void rhs_b(double *f, double *fb, double *x, double *xb, double *p, double *pb
        , int mode) {
    double temp3;
    double temp2;
    double temp1;
    double temp0;
    double temp0b;
    double temp3b;
    double temp6b;
    double temp10;
    double temp9b;
    double temp0b0;
    double temp11b;
    double temp3b1;
    double temp3b0;
    double temp;
    double temp6b0;
    double temp9;
    double temp8;
    double temp7;
    double temp10b;
    double temp6;
    double temp5;
    double temp4;
    if (mode == 0) {
        temp3b = p[8]*fb[1];
        temp3b0 = a*InputSat*temp3b/PI;
        temp2 = 180*x[1] + 5.4;
        temp0 = x[1]*x[0]/temp2;
        temp1 = exp(-(b*x[1]));
        temp0b = -(temp1*temp3b/temp2);
        pb[2] = temp3b0;
        pb[1] = temp3b0;
        xb[1] = (x[0]-180*temp0)*temp0b + temp0*exp(-(b*x[1]))*b*temp3b - 
            temp3b0;
        xb[0] = x[1]*temp0b;
        pb[8] = (a*InputSat*((p[2]+p[1]-x[1])/PI)-temp1*temp0)*fb[1];
        fb[1] = 0.0;
        temp0b0 = p[8]*fb[0];
        temp = exp(-(b*x[1]));
        xb[1] = xb[1] + (temp*x[0]-x[1]*x[0]*exp(-(b*x[1]))*b)*temp0b0;
        xb[0] = xb[0] + (temp*x[1]-a*InputSat/PI)*temp0b0;
        pb[8] = pb[8] + (temp*(x[1]*x[0])-a*InputSat*(x[0]/PI))*fb[0];
        fb[0] = 0.0;
    } else
        if (mode == 1) {
            temp11b = p[8]*fb[1];
            temp9 = (p[2]+p[1]-x[1])/PI;
            temp10 = p[3] + p[0] + p[5]*(x[1]-p[4]);
            temp10b = a*temp9*temp11b;
            temp9b = a*temp10*temp11b/PI;
            temp8 = 180*x[1] + 5.4;
            temp6 = x[1]*x[0]/temp8;
            temp7 = exp(-(b*x[1]));
            temp6b = -(temp7*temp11b/temp8);
            pb[3] = temp10b;
            pb[0] = temp10b;
            pb[5] = (x[1]-p[4])*temp10b;
            xb[1] = (x[0]-180*temp6)*temp6b + temp6*exp(-(b*x[1]))*b*temp11b -
                temp9b + p[5]*temp10b;
            pb[4] = -(p[5]*temp10b);
            pb[2] = temp9b;
            pb[1] = temp9b;
            xb[0] = x[1]*temp6b;
            pb[8] = (a*(temp10*temp9)-temp7*temp6)*fb[1];
            fb[1] = 0.0;
            temp6b0 = p[8]*fb[0];
            temp5 = exp(-(b*x[1]));
            temp4 = x[0]/PI;
            temp3 = p[3] + p[0] + p[5]*(x[1]-p[4]);
            temp3b1 = -(a*temp4*temp6b0);
            xb[1] = xb[1] + p[5]*temp3b1 + (temp5*x[0]-x[1]*x[0]*exp(-(b*x[1])
                )*b)*temp6b0;
            xb[0] = xb[0] + (temp5*x[1]-a*temp3/PI)*temp6b0;
            pb[3] = pb[3] + temp3b1;
            pb[0] = pb[0] + temp3b1;
            pb[5] = pb[5] + (x[1]-p[4])*temp3b1;
            pb[4] = pb[4] - p[5]*temp3b1;
            pb[8] = pb[8] + (temp5*(x[1]*x[0])-a*(temp3*temp4))*fb[0];
            fb[0] = 0.0;
        } else {
            *pb = 0.0;
            *xb = 0.0;
        }
}









/*        Generated by TAPENADE     (INRIA, Tropics team)
    Tapenade 3.4 (r3375) - 10 Feb 2010 15:08


  Differentiation of rhs_b in forward (tangent) mode:
   variations   of useful results: *xb *fb *pb
   with respect to varying inputs: *p *x *fb
   RW status of diff variables: *p:in *xb:out *x:in *fb:in-out
                *pb:out
*/
void rhs_b_d(double *f, double *fb, double *fbd, double *x, double *xd, double
        *xb, double *xbd, double *p, double *pd, double *pb, double *pbd, int 
        mode) {
    double temp3;
    double temp3d;
    double temp2;
    double temp2d;
    double temp1;
    double temp1d;
    double temp0;
    double temp0d;
    double temp0b;
    double temp0bd;
    double temp3b;
    double temp3bd;
    double temp6b;
    double temp6bd;
    double temp10;
    double temp10d;
    double temp9b;
    double temp9bd;
    double temp0b0;
    double temp0b0d;
    double temp11b;
    double temp11bd;
    double temp3b1;
    double temp3b1d;
    double temp3b0;
    double temp3b0d;
    double temp;
    double tempd;
    double temp6b0;
    double temp6b0d;
    double temp9;
    double temp9d;
    double temp8;
    double temp8d;
    double temp7;
    double temp7d;
    double temp10b;
    double temp10bd;
    double temp6;
    double temp6d;
    double temp5;
    double temp5d;
    double temp4;
    double temp4d;
    if (mode == 0) {
        temp3bd = pd[8]*fb[1] + p[8]*fbd[1];
        temp3b = p[8]*fb[1];
        temp3b0d = a*InputSat*temp3bd/PI;
        temp3b0 = a*InputSat*temp3b/PI;
        temp2d = 180*xd[1];
        temp2 = 180*x[1] + 5.4;
        temp0d = ((xd[1]*x[0]+x[1]*xd[0])*temp2-x[1]*x[0]*temp2d)/(temp2*temp2
            );
        temp0 = x[1]*x[0]/temp2;
        temp1d = -(b*xd[1]*exp(-(b*x[1])));
        temp1 = exp(-(b*x[1]));
        temp0bd = -(((temp1d*temp3b+temp1*temp3bd)*temp2-temp1*temp3b*temp2d)/
            (temp2*temp2));
        temp0b = -(temp1*temp3b/temp2);
        pbd[2] = temp3b0d;
        pb[2] = temp3b0;
        pbd[1] = temp3b0d;
        pb[1] = temp3b0;
        xbd[1] = (xd[0]-180*temp0d)*temp0b + (x[0]-180*temp0)*temp0bd + b*((
            temp0d*temp3b+temp0*temp3bd)*exp(-(b*x[1]))-temp0*temp3b*b*xd[1]*
            exp(-(b*x[1]))) - temp3b0d;
        xb[1] = (x[0]-180*temp0)*temp0b + temp0*exp(-(b*x[1]))*b*temp3b - 
            temp3b0;
        xbd[0] = xd[1]*temp0b + x[1]*temp0bd;
        xb[0] = x[1]*temp0b;
        pbd[8] = (a*InputSat*(pd[2]+pd[1]-xd[1])/PI-temp1d*temp0-temp1*temp0d)
            *fb[1] + (a*InputSat*((p[2]+p[1]-x[1])/PI)-temp1*temp0)*fbd[1];
        pb[8] = (a*InputSat*((p[2]+p[1]-x[1])/PI)-temp1*temp0)*fb[1];
        fbd[1] = 0.0;
        fb[1] = 0.0;
        temp0b0d = pd[8]*fb[0] + p[8]*fbd[0];
        temp0b0 = p[8]*fb[0];
        tempd = -(b*xd[1]*exp(-(b*x[1])));
        temp = exp(-(b*x[1]));
        xbd[1] = xbd[1] + (tempd*x[0]+temp*xd[0]-b*((xd[1]*x[0]+x[1]*xd[0])*
            exp(-(b*x[1]))-x[1]*x[0]*b*xd[1]*exp(-(b*x[1]))))*temp0b0 + (temp*
            x[0]-x[1]*x[0]*exp(-(b*x[1]))*b)*temp0b0d;
        xb[1] = xb[1] + (temp*x[0]-x[1]*x[0]*exp(-(b*x[1]))*b)*temp0b0;
        xbd[0] = xbd[0] + (tempd*x[1]+temp*xd[1])*temp0b0 + (temp*x[1]-a*
            InputSat/PI)*temp0b0d;
        xb[0] = xb[0] + (temp*x[1]-a*InputSat/PI)*temp0b0;
        pbd[8] = pbd[8] + ((tempd*x[1]+temp*xd[1])*x[0]+temp*x[1]*xd[0]-a*
            InputSat*xd[0]/PI)*fb[0] + (temp*(x[1]*x[0])-a*InputSat*(x[0]/PI))
            *fbd[0];
        pb[8] = pb[8] + (temp*(x[1]*x[0])-a*InputSat*(x[0]/PI))*fb[0];
        fbd[0] = 0.0;
        fb[0] = 0.0;
    } else
        if (mode == 1) {
            temp11bd = pd[8]*fb[1] + p[8]*fbd[1];
            temp11b = p[8]*fb[1];
            temp9d = (pd[2]+pd[1]-xd[1])/PI;
            temp9 = (p[2]+p[1]-x[1])/PI;
            temp10d = pd[3] + pd[0] + pd[5]*(x[1]-p[4]) + p[5]*(xd[1]-pd[4]);
            temp10 = p[3] + p[0] + p[5]*(x[1]-p[4]);
            temp10bd = a*(temp9d*temp11b+temp9*temp11bd);
            temp10b = a*temp9*temp11b;
            temp9bd = a*(temp10d*temp11b+temp10*temp11bd)/PI;
            temp9b = a*temp10*temp11b/PI;
            temp8d = 180*xd[1];
            temp8 = 180*x[1] + 5.4;
            temp6d = ((xd[1]*x[0]+x[1]*xd[0])*temp8-x[1]*x[0]*temp8d)/(temp8*
                temp8);
            temp6 = x[1]*x[0]/temp8;
            temp7d = -(b*xd[1]*exp(-(b*x[1])));
            temp7 = exp(-(b*x[1]));
            temp6bd = -(((temp7d*temp11b+temp7*temp11bd)*temp8-temp7*temp11b*
                temp8d)/(temp8*temp8));
            temp6b = -(temp7*temp11b/temp8);
            pbd[3] = temp10bd;
            pb[3] = temp10b;
            pbd[0] = temp10bd;
            pb[0] = temp10b;
            pbd[5] = (xd[1]-pd[4])*temp10b + (x[1]-p[4])*temp10bd;
            pb[5] = (x[1]-p[4])*temp10b;
            xbd[1] = (xd[0]-180*temp6d)*temp6b + (x[0]-180*temp6)*temp6bd + b*
                ((temp6d*temp11b+temp6*temp11bd)*exp(-(b*x[1]))-temp6*temp11b*
                b*xd[1]*exp(-(b*x[1]))) - temp9bd + pd[5]*temp10b + p[5]*
                temp10bd;
            xb[1] = (x[0]-180*temp6)*temp6b + temp6*exp(-(b*x[1]))*b*temp11b -
                temp9b + p[5]*temp10b;
            pbd[4] = -(pd[5]*temp10b+p[5]*temp10bd);
            pb[4] = -(p[5]*temp10b);
            pbd[2] = temp9bd;
            pb[2] = temp9b;
            pbd[1] = temp9bd;
            pb[1] = temp9b;
            xbd[0] = xd[1]*temp6b + x[1]*temp6bd;
            xb[0] = x[1]*temp6b;
            pbd[8] = (a*(temp10d*temp9+temp10*temp9d)-temp7d*temp6-temp7*
                temp6d)*fb[1] + (a*(temp10*temp9)-temp7*temp6)*fbd[1];
            pb[8] = (a*(temp10*temp9)-temp7*temp6)*fb[1];
            fbd[1] = 0.0;
            fb[1] = 0.0;
            temp6b0d = pd[8]*fb[0] + p[8]*fbd[0];
            temp6b0 = p[8]*fb[0];
            temp5d = -(b*xd[1]*exp(-(b*x[1])));
            temp5 = exp(-(b*x[1]));
            temp4d = xd[0]/PI;
            temp4 = x[0]/PI;
            temp3d = pd[3] + pd[0] + pd[5]*(x[1]-p[4]) + p[5]*(xd[1]-pd[4]);
            temp3 = p[3] + p[0] + p[5]*(x[1]-p[4]);
            temp3b1d = -(a*(temp4d*temp6b0+temp4*temp6b0d));
            temp3b1 = -(a*temp4*temp6b0);
            xbd[1] = xbd[1] + pd[5]*temp3b1 + p[5]*temp3b1d + (temp5d*x[0]+
                temp5*xd[0]-b*((xd[1]*x[0]+x[1]*xd[0])*exp(-(b*x[1]))-x[1]*x[0
                ]*b*xd[1]*exp(-(b*x[1]))))*temp6b0 + (temp5*x[0]-x[1]*x[0]*exp
                (-(b*x[1]))*b)*temp6b0d;
            xb[1] = xb[1] + p[5]*temp3b1 + (temp5*x[0]-x[1]*x[0]*exp(-(b*x[1])
                )*b)*temp6b0;
            xbd[0] = xbd[0] + (temp5d*x[1]+temp5*xd[1]-a*temp3d/PI)*temp6b0 + 
                (temp5*x[1]-a*temp3/PI)*temp6b0d;
            xb[0] = xb[0] + (temp5*x[1]-a*temp3/PI)*temp6b0;
            pbd[3] = pbd[3] + temp3b1d;
            pb[3] = pb[3] + temp3b1;
            pbd[0] = pbd[0] + temp3b1d;
            pb[0] = pb[0] + temp3b1;
            pbd[5] = pbd[5] + (xd[1]-pd[4])*temp3b1 + (x[1]-p[4])*temp3b1d;
            pb[5] = pb[5] + (x[1]-p[4])*temp3b1;
            pbd[4] = pbd[4] - pd[5]*temp3b1 - p[5]*temp3b1d;
            pb[4] = pb[4] - p[5]*temp3b1;
            pbd[8] = pbd[8] + ((temp5d*x[1]+temp5*xd[1])*x[0]+temp5*x[1]*xd[0]
                -a*(temp3d*temp4+temp3*temp4d))*fb[0] + (temp5*(x[1]*x[0])-a*(
                temp3*temp4))*fbd[0];
            pb[8] = pb[8] + (temp5*(x[1]*x[0])-a*(temp3*temp4))*fb[0];
            fbd[0] = 0.0;
            fb[0] = 0.0;
        } else {
            *pb = 0.0;
            *xb = 0.0;
            *xbd = 0.0;
            *pbd = 0.0;
        }
}




void sigmafcn(double* sigma, double *x, double *p) {
	sigma[0]=(p[3]+p[0])+p[5]*(x[1]-p[4])-InputSat;
}

void sigmafcn_d(double *sigma, double *sigmad, double *x, double *xd, double *
        p, double *pd) {
    sigmad[0] = pd[3] + pd[0] + pd[5]*(x[1]-p[4]) + p[5]*(xd[1]-pd[4]);
    sigma[0] = p[3] + p[0] + p[5]*(x[1]-p[4]) - InputSat;
}
